searchData={"items":[{"type":"module","title":"SwitchX","doc":"","ref":"SwitchX.html"},{"type":"function","title":"SwitchX.api/2","doc":"Send a FreeSWITCH API command.\n\nReturns\n```\n  {:ok, term}\n```","ref":"SwitchX.html#api/2"},{"type":"function","title":"Examples - SwitchX.api/2","doc":"iex> SwitchX.api(\n          conn,\n          \"uuid_getvar a1024ff5-a5b3-4c0a-abd3-fd4a89508b5b current_application\"\n         )\n    %SwitchX.Event{\n      body: \"park\",\n      headers: %{\"Content-Length\" => \"4\", \"Content-Type\" => \"api/response\"}\n    }","ref":"SwitchX.html#api/2-examples"},{"type":"function","title":"SwitchX.auth/2","doc":"Reply the auth/request package from FreeSWITCH.\n\nReturns\n```\n  {:ok, \"Accepted\"} | {:error, \"Denied\"}\n```","ref":"SwitchX.html#auth/2"},{"type":"function","title":"Examples - SwitchX.auth/2","doc":"iex> SwitchX.auth(conn, \"ClueCon\")\n    {:ok, \"Accepted\"}\n\n    iex> SwitchX.auth(conn, \"Incorrect\")\n    {:error, \"Denied\"}","ref":"SwitchX.html#auth/2-examples"},{"type":"function","title":"SwitchX.bg_api/2","doc":"Send a FreeSWITCH API command, non-blocking mode.\nThis will let you execute a job in the background, and the result will be sent as an BACKGROUND_JOB event\nwith an indicated UUID to match the reply to the command.","ref":"SwitchX.html#bg_api/2"},{"type":"function","title":"SwitchX.close/1","doc":"Closes the connection (conn) and stop the socket","ref":"SwitchX.html#close/1"},{"type":"function","title":"SwitchX.execute/4","doc":"execute is used to invoke dialplan applications,","ref":"SwitchX.html#execute/4"},{"type":"function","title":"Examples - SwitchX.execute/4","doc":"iex> SwitchX.execute(conn, uuid, \"playback\", \"ivr/ivr-welcome_to_freeswitch.wav\")","ref":"SwitchX.html#execute/4-examples"},{"type":"function","title":"SwitchX.execute/5","doc":"","ref":"SwitchX.html#execute/5"},{"type":"function","title":"SwitchX.exit/1","doc":"Closes the socket connection.","ref":"SwitchX.html#exit/1"},{"type":"function","title":"SwitchX.hangup/2","doc":"Hang up the call with a hangup_cause.","ref":"SwitchX.html#hangup/2"},{"type":"function","title":"SwitchX.hangup/3","doc":"","ref":"SwitchX.html#hangup/3"},{"type":"function","title":"SwitchX.linger/1","doc":"Tells FreeSWITCH not to close the socket connection when a channel hangs up.\nInstead, it keeps the socket connection open until the last event related\nto the channel has been received by the socket client.\n\nReturns\n```\n  {:ok, \"Lingering\"}\n```","ref":"SwitchX.html#linger/1"},{"type":"function","title":"Examples - SwitchX.linger/1","doc":"iex> SwitchX.linger(context.conn)\n    {:ok, \"Lingering\"}","ref":"SwitchX.html#linger/1-examples"},{"type":"function","title":"SwitchX.listen_event/2","doc":"Enable or disable events by class or all.\n\nReturns\n```\n  :ok\n```","ref":"SwitchX.html#listen_event/2"},{"type":"function","title":"Examples - SwitchX.listen_event/2","doc":"iex> SwitchX.listen_event(conn, \"BACKGROUND_JOB\")\n    :ok","ref":"SwitchX.html#listen_event/2-examples"},{"type":"function","title":"SwitchX.multiset/2","doc":"","ref":"SwitchX.html#multiset/2"},{"type":"function","title":"SwitchX.my_events/1","doc":"The 'myevents' subscription allows your socket to receive all related events from a outbound socket session","ref":"SwitchX.html#my_events/1"},{"type":"function","title":"SwitchX.my_events/2","doc":"The 'myevents' subscription allows your inbound socket connection to behave like an outbound socket connect.\nIt will \"lock on\" to the events for a particular uuid and will ignore all other events","ref":"SwitchX.html#my_events/2"},{"type":"function","title":"SwitchX.originate/2","doc":"","ref":"SwitchX.html#originate/2"},{"type":"function","title":"SwitchX.originate/3","doc":"","ref":"SwitchX.html#originate/3"},{"type":"function","title":"SwitchX.originate/4","doc":"","ref":"SwitchX.html#originate/4"},{"type":"function","title":"SwitchX.playback/2","doc":"","ref":"SwitchX.html#playback/2"},{"type":"function","title":"SwitchX.playback/3","doc":"","ref":"SwitchX.html#playback/3"},{"type":"function","title":"SwitchX.playback_async/2","doc":"","ref":"SwitchX.html#playback_async/2"},{"type":"function","title":"SwitchX.playback_async/3","doc":"","ref":"SwitchX.html#playback_async/3"},{"type":"function","title":"SwitchX.send_event/3","doc":"Send an event into the event system (multi line input for headers).\n```\nsendevent  \n \n\n \n```\n\nReturns\n```\n  {:ok, term}\n```","ref":"SwitchX.html#send_event/3"},{"type":"function","title":"Examples - SwitchX.send_event/3","doc":"iex>  event_headers =\n      SwitchX.Event.Headers.new(%{\n        \"profile\": \"external\",\n      })\n    event = SwitchX.Event.new(event_headers, \"\")\n    SwitchX.send_event(conn, \"SEND_INFO\", event)\n    {:ok, response}","ref":"SwitchX.html#send_event/3-examples"},{"type":"function","title":"SwitchX.send_event/4","doc":"","ref":"SwitchX.html#send_event/4"},{"type":"function","title":"SwitchX.send_message/2","doc":"sendmsg is used to control the behavior of FreeSWITCH.\nUUID is mandatory when conn is inbound mode, and it refers to a specific call\n(i.e., a channel or call leg or session).\n\nReturns a payload with an command/reply event","ref":"SwitchX.html#send_message/2"},{"type":"function","title":"Examples - SwitchX.send_message/2","doc":"iex> message = SwitchX.Event.Headers.new(%{\n        \"call-command\": \"hangup\",\n        \"hangup-cause\": \"NORMAL_CLEARING\",\n      }) |> SwitchX.Event.new()\n\n      SwitchX.send_message(conn, uuid, message)\n      {:ok, event}","ref":"SwitchX.html#send_message/2-examples"},{"type":"function","title":"SwitchX.send_message/3","doc":"","ref":"SwitchX.html#send_message/3"},{"type":"module","title":"SwitchX.Connection.Inbound","doc":"Provides an abstraction to a FreeSWITCH inbound connection\n\nInbound mode means you run your applications as clients,\nand connect to the FreeSWITCH server to invoke commands and control FreeSWITCH.","ref":"SwitchX.Connection.Inbound.html"},{"type":"function","title":"SwitchX.Connection.Inbound.start_link/1","doc":"Starts a new inbond connection.\n\nReturns `{:ok, Pid}`","ref":"SwitchX.Connection.Inbound.html#start_link/1"},{"type":"function","title":"Examples - SwitchX.Connection.Inbound.start_link/1","doc":"iex> paramaters = [\n      host: \"127.0.0.1\",\n      port: 8021,\n    ]\n\n    iex> SwitchX.Connection.Inbound.start_link(paramaters)\n    {:ok, connection_pid}","ref":"SwitchX.Connection.Inbound.html#start_link/1-examples"},{"type":"module","title":"SwitchX.Connection.Outbound","doc":"Outbound mode means you make a daemon, and then have FreeSWITCH connect to it.\nYou add an extension to the dialplan, and put   \n\nIn outbound mode, also known as the \"socket application\" (or socket client), FreeSWITCH makes outbound connections to another process\n(similar to Asterisk's FAGI model). Using outbound connections you can have FreeSWITCH call your own application(s) when particular events occur.\n\nSee Event Socket Outbound for more details regarding things specific to outbound mode.","ref":"SwitchX.Connection.Outbound.html"},{"type":"function","title":"SwitchX.Connection.Outbound.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\n`arg` is passed as the argument to `Task.start_link/1` in the `:start` field\nof the spec.\n\nFor more information, see the `Supervisor` module,\nthe `Supervisor.child_spec/2` function and the `t:Supervisor.child_spec/0` type.","ref":"SwitchX.Connection.Outbound.html#child_spec/1"},{"type":"function","title":"SwitchX.Connection.Outbound.start_link/2","doc":"Starts a new outbound server.\n\nReturns `{:ok, Pid}`","ref":"SwitchX.Connection.Outbound.html#start_link/2"},{"type":"function","title":"Examples - SwitchX.Connection.Outbound.start_link/2","doc":"iex> parameters [\n      host: \"127.0.0.1\",\n      port: 9998,\n    ]\n    iex> SwitchX.Connection.Outbound.start_link(Examples.OutboundSession, parameters)\n    {:ok, server_pid}","ref":"SwitchX.Connection.Outbound.html#start_link/2-examples"},{"type":"module","title":"SwitchX.Event","doc":"","ref":"SwitchX.Event.html"},{"type":"function","title":"SwitchX.Event.dump/1","doc":"Dumps a SwitchX.Event into a string URI encoded\n\nReturns\n```\n  event_string\n```","ref":"SwitchX.Event.html#dump/1"},{"type":"function","title":"Example - SwitchX.Event.dump/1","doc":"iex> SwitchX.Event.new(SwitchX.Event.Headers.new(%{foo: \"bar 53\"}), \"body\")\n         |> SwitchX.Event.dump()\n\n    \"foo: bar%2053\n\n    body\"","ref":"SwitchX.Event.html#dump/1-example"},{"type":"function","title":"SwitchX.Event.fetch/2","doc":"","ref":"SwitchX.Event.html#fetch/2"},{"type":"function","title":"SwitchX.Event.get/3","doc":"","ref":"SwitchX.Event.html#get/3"},{"type":"function","title":"SwitchX.Event.get_and_update/3","doc":"","ref":"SwitchX.Event.html#get_and_update/3"},{"type":"function","title":"SwitchX.Event.merge/2","doc":"Updates a SwitchX.Event with another event message and body, see Map.merge/2","ref":"SwitchX.Event.html#merge/2"},{"type":"function","title":"SwitchX.Event.new/0","doc":"","ref":"SwitchX.Event.html#new/0"},{"type":"function","title":"SwitchX.Event.new/1","doc":"Create a Event from a plain message from freeswitch,","ref":"SwitchX.Event.html#new/1"},{"type":"function","title":"SwitchX.Event.new/2","doc":"Given a SwichX.Event.Headers and a body string create a new Event","ref":"SwitchX.Event.html#new/2"},{"type":"function","title":"SwitchX.Event.pop/2","doc":"","ref":"SwitchX.Event.html#pop/2"},{"type":"module","title":"SwitchX.Event.Headers","doc":"This Module defines a struct for an ESL event Headers.\n\nThe freeswitch ESL event implementation commonly contains headers\nwith a mapped key-value text as:\n\nEvent-Name: CUSTOM\nvariable_caller_id_name: caller\nvariable_caller_id_number: 9494\n...","ref":"SwitchX.Event.Headers.html"},{"type":"function","title":"SwitchX.Event.Headers.fetch/2","doc":"","ref":"SwitchX.Event.Headers.html#fetch/2"},{"type":"function","title":"SwitchX.Event.Headers.get/3","doc":"","ref":"SwitchX.Event.Headers.html#get/3"},{"type":"function","title":"SwitchX.Event.Headers.get_and_update/3","doc":"","ref":"SwitchX.Event.Headers.html#get_and_update/3"},{"type":"function","title":"SwitchX.Event.Headers.new/1","doc":"Create a Event header from a enumerable,\nif it has duplicated mappable keys the latest one prevails.","ref":"SwitchX.Event.Headers.html#new/1"},{"type":"function","title":"SwitchX.Event.Headers.pop/2","doc":"","ref":"SwitchX.Event.Headers.html#pop/2"},{"type":"extras","title":"README","doc":"![CI](https://github.com/kalmik/switchx/workflows/Elixir%20CI/badge.svg?branch=master)\n\n# SwitchX\n\n**FreeSWITCH Event Socket Protocol client implementation with  Elixir**\n\nDocumentation can be found at [https://hexdocs.pm/switchx](https://hexdocs.pm/switchx).","ref":"readme.html"},{"type":"extras","title":"Installation - README","doc":"```elixir\ndef deps do\n  [\n    {:switchx, \"~> 0.1.1\"}\n  ]\nend\n```","ref":"readme.html#installation"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}